Overview | Package | Class | Tree | Deprecated | Index | Help
| Protege 3.4 rc2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.stanford.smi.protege.model.framestore
Interface FrameStore

All Known Implementing Classes:
  AbstractFrameStore, ArgumentCheckingFrameStore, ChangeMonitorFrameStore, CleanDispatchFrameStore, DeleteSimplificationFrameStore, DeletionHookFrameStore, EventDispatchFrameStore, EventGeneratorFrameStore, EventSinkFrameStore, FacetCheckingFrameStore, FrameCalculatorFrameStore, FrameStoreAdapter, ImmutableNamesFrameStore, InMemoryFrameStore, ModificationFrameStore, ModificationRecordFrameStore, RemoteClientFrameStore, SimpleFrameStore, TemplateFrameStore, TransactionFrameStore, UndoFrameStore

    public interface FrameStore

Field Summary
`static int` | `UNLIMITED_MATCHES`

Method Summary
`void` | `addDirectSuperclass(Cls cls, Cls superclass)`
`void` | `addDirectSuperslot(Slot slot, Slot superslot)`
`void` | `addDirectTemplateSlot(Cls cls, Slot slot)`
`void` | `addDirectType(Instance instance, Cls type)`
`boolean` | `beginTransaction(String name)`
`void` | `close()`
`boolean` | `commitTransaction()`
`Cls` | `createCls(FrameID id, Collection directTypes, Collection directSuperclasses, boolean loadDefaultValues)`
`Facet` | `createFacet(FrameID id, Collection directTypes, boolean loadDefaultValues)`
`SimpleInstance` | `createSimpleInstance(FrameID id, Collection directTypes, boolean loadDefaultValues)`
`Slot` | `createSlot(FrameID id, Collection directTypes, Collection directSuperslots, boolean loadDefaultValues)`
`void` | `deleteCls(Cls cls)` Delete a single leaf class.
`void` | `deleteFacet(Facet facet)`
`void` | `deleteSimpleInstance(SimpleInstance simpleInstance)`
`void` | `deleteSlot(Slot slot)`
`void` | `executeQuery(Query query, QueryCallback callback)` The executeQuery method allows for complex queries.
`int` | `getClsCount()`
`Set<Cls>` | `getClses()`
`Set<Cls>` | `getClsesWithAnyDirectTemplateSlotValue(Slot slot)`
`Set` | `getClsesWithDirectTemplateFacetValue(Slot slot, Facet facet, Object value)`
`Set` | `getClsesWithDirectTemplateSlotValue(Slot slot, Object value)`
`Set<Cls>` | `getClsesWithMatchingBrowserText(String string, Collection superclasses, int maxMatches)`
`Set` | `getClsesWithMatchingDirectTemplateFacetValue(Slot slot, Facet facet, String value, int maxMatches)`
`Set` | `getClsesWithMatchingDirectTemplateSlotValue(Slot slot, String value, int maxMatches)`
`FrameStore` | `getDelegate()`
`List` | `getDirectDomain(Slot slot)`
`List<Instance>` | `getDirectInstances(Cls cls)`
`Set` | `getDirectlyOverriddenTemplateFacets(Cls cls, Slot slot)`
`Set` | `getDirectlyOverriddenTemplateSlots(Cls cls)`
`List` | `getDirectOwnSlotValues(Frame frame, Slot slot)`
`Set` | `getDirectOwnSlotValuesClosure(Frame frame, Slot slot)`
`int` | `getDirectOwnSlotValuesCount(Frame frame, Slot slot)`
`List<Cls>` | `getDirectSubclasses(Cls cls)`
`List` | `getDirectSubslots(Slot slot)`
`List<Cls>` | `getDirectSuperclasses(Cls cls)`
`List` | `getDirectSuperslots(Slot slot)`
`List` | `getDirectTemplateFacetValues(Cls cls, Slot slot, Facet facet)`
`List` | `getDirectTemplateSlots(Cls cls)`
`List` | `getDirectTemplateSlotValues(Cls cls, Slot slot)`
`List` | `getDirectTypes(Instance instance)`
`Set` | `getDomain(Slot slot)`
`List<AbstractEvent>` | `getEvents()`
`int` | `getFacetCount()`
`Set<Facet>` | `getFacets()`
`Frame` | `getFrame(FrameID id)`
`Frame` | `getFrame(String name)`
`int` | `getFrameCount()`
`String` | `getFrameName(Frame frame)`
`Set<Frame>` | `getFrames()`
`Set<Frame>` | `getFramesWithAnyDirectOwnSlotValue(Slot slot)`
`Set<Frame>` | `getFramesWithDirectOwnSlotValue(Slot slot, Object value)`
`Set<Frame>` | `getFramesWithMatchingDirectOwnSlotValue(Slot slot, String value, int maxMatches)`
`Set<Instance>` | `getInstances(Cls cls)`
`Set<Reference>` | `getMatchingReferences(String string, int maxMatches)`
`String` | `getName()`
`Set` | `getOverriddenTemplateFacets(Cls cls, Slot slot)`
`Set` | `getOverriddenTemplateSlots(Cls cls)`
`Set` | `getOwnFacets(Frame frame, Slot slot)`
`Collection` | `getOwnFacetValues(Frame frame, Slot slot, Facet facet)`
`Set<Slot>` | `getOwnSlots(Frame frame)`
`Collection` | `getOwnSlotValues(Frame frame, Slot slot)`
`Set<Reference>` | `getReferences(Object object)`
`int` | `getSimpleInstanceCount()`
`int` | `getSlotCount()`
`Set<Slot>` | `getSlots()`
`Set<Cls>` | `getSubclasses(Cls cls)`
`Set` | `getSubslots(Slot slot)`
`Set` | `getSuperclasses(Cls cls)`
`Set` | `getSuperslots(Slot slot)`
`Set<Facet>` | `getTemplateFacets(Cls cls, Slot slot)`
`Collection` | `getTemplateFacetValues(Cls cls, Slot slot, Facet facet)`
`Set` | `getTemplateSlots(Cls cls)`
`Collection` | `getTemplateSlotValues(Cls cls, Slot slot)`
`TransactionMonitor` | `getTransactionStatusMonitor()` Retrieves a transaction status monitor for transactions.
`Set` | `getTypes(Instance instance)`
`void` | `moveDirectOwnSlotValue(Frame frame, Slot slot, int indexFrom, int indexTo)`
`void` | `moveDirectSubclass(Cls cls, Cls subclass, int index)`
`void` | `moveDirectSubslot(Slot slot, Slot subslot, int index)`
`void` | `moveDirectTemplateSlot(Cls cls, Slot slot, int index)`
`void` | `moveDirectType(Instance instance, Cls type, int index)`
`void` | `reinitialize()`
`void` | `removeDirectSuperclass(Cls cls, Cls superclass)`
`void` | `removeDirectSuperslot(Slot slot, Slot superslot)`
`void` | `removeDirectTemplateFacetOverrides(Cls cls, Slot slot)`
`void` | `removeDirectTemplateSlot(Cls cls, Slot slot)`
`void` | `removeDirectType(Instance instance, Cls type)`
`void` | `replaceFrame(Frame original, Frame replacement)`
`boolean` | `rollbackTransaction()`
`void` | `setDelegate(FrameStore delegate)`
`void` | `setDirectOwnSlotValues(Frame frame, Slot slot, Collection values)`
`void` | `setDirectTemplateFacetValues(Cls cls, Slot slot, Facet facet, Collection values)`
`void` | `setDirectTemplateSlotValues(Cls cls, Slot slot, Collection values)`

Field Detail

### UNLIMITED_MATCHES

    static final int UNLIMITED_MATCHES

See Also:
  Constant Field Values

Method Detail

### getName

    String getName()

### setDelegate

    void setDelegate(FrameStore delegate)

### getDelegate

    FrameStore getDelegate()

### reinitialize

    void reinitialize()

### getClsCount

    int getClsCount()

### getSlotCount

    int getSlotCount()

### getFacetCount

    int getFacetCount()

### getSimpleInstanceCount

    int getSimpleInstanceCount()

### getFrameCount

    int getFrameCount()

### getClses

    Set<Cls> getClses()

### getSlots

    Set<Slot> getSlots()

### getFacets

    Set<Facet> getFacets()

### getFrames

    Set<Frame> getFrames()

### getFrame

    Frame getFrame(FrameID id)

### getFrame

    Frame getFrame(String name)

### getFrameName

    String getFrameName(Frame frame)

### createCls

    Cls createCls(FrameID id,
                  Collection directTypes,
                  Collection directSuperclasses,
                  boolean loadDefaultValues)

### createSlot

    Slot createSlot(FrameID id,
                    Collection directTypes,
                    Collection directSuperslots,
                    boolean loadDefaultValues)

### createFacet

    Facet createFacet(FrameID id,
                      Collection directTypes,
                      boolean loadDefaultValues)

### createSimpleInstance

    SimpleInstance createSimpleInstance(FrameID id,
                                        Collection directTypes,
                                        boolean loadDefaultValues)

### deleteCls

    void deleteCls(Cls cls)

  Delete a single leaf class. The operation fails if the class has subclasses or instances.

  Parameters:
    `cls` - Class to be deleted
  Throws:
    `IllegalArgumentException` - if the class has either subclasses or instances.

### deleteSlot

    void deleteSlot(Slot slot)

### deleteFacet

    void deleteFacet(Facet facet)

### deleteSimpleInstance

    void deleteSimpleInstance(SimpleInstance simpleInstance)

### getOwnSlots

    Set<Slot> getOwnSlots(Frame frame)

### getOwnSlotValues

    Collection getOwnSlotValues(Frame frame,
                                Slot slot)

### getDirectOwnSlotValues

    List getDirectOwnSlotValues(Frame frame,
                                Slot slot)

### getDirectOwnSlotValuesCount

    int getDirectOwnSlotValuesCount(Frame frame,
                                    Slot slot)

### moveDirectOwnSlotValue

    void moveDirectOwnSlotValue(Frame frame,
                                Slot slot,
                                int indexFrom,
                                int indexTo)

### setDirectOwnSlotValues

    void setDirectOwnSlotValues(Frame frame,
                                Slot slot,
                                Collection values)

### getOwnFacets

    Set getOwnFacets(Frame frame,
                     Slot slot)

### getOwnFacetValues

    Collection getOwnFacetValues(Frame frame,
                                 Slot slot,
                                 Facet facet)

### getTemplateSlots

    Set getTemplateSlots(Cls cls)

### getDirectTemplateSlots

    List getDirectTemplateSlots(Cls cls)

### getDirectDomain

    List getDirectDomain(Slot slot)

### getDomain

    Set getDomain(Slot slot)

### getOverriddenTemplateSlots

    Set getOverriddenTemplateSlots(Cls cls)

### getDirectlyOverriddenTemplateSlots

    Set getDirectlyOverriddenTemplateSlots(Cls cls)

### addDirectTemplateSlot

    void addDirectTemplateSlot(Cls cls,
                               Slot slot)

### removeDirectTemplateSlot

    void removeDirectTemplateSlot(Cls cls,
                                  Slot slot)

### moveDirectTemplateSlot

    void moveDirectTemplateSlot(Cls cls,
                                Slot slot,
                                int index)

### getTemplateSlotValues

    Collection getTemplateSlotValues(Cls cls,
                                     Slot slot)

### getDirectTemplateSlotValues

    List getDirectTemplateSlotValues(Cls cls,
                                     Slot slot)

### setDirectTemplateSlotValues

    void setDirectTemplateSlotValues(Cls cls,
                                     Slot slot,
                                     Collection values)

### getTemplateFacets

    Set<Facet> getTemplateFacets(Cls cls,
                                 Slot slot)

### getOverriddenTemplateFacets

    Set getOverriddenTemplateFacets(Cls cls,
                                    Slot slot)

### getDirectlyOverriddenTemplateFacets

    Set getDirectlyOverriddenTemplateFacets(Cls cls,
                                            Slot slot)

### removeDirectTemplateFacetOverrides

    void removeDirectTemplateFacetOverrides(Cls cls,
                                            Slot slot)

### getTemplateFacetValues

    Collection getTemplateFacetValues(Cls cls,
                                      Slot slot,
                                      Facet facet)

### getDirectTemplateFacetValues

    List getDirectTemplateFacetValues(Cls cls,
                                      Slot slot,
                                      Facet facet)

### setDirectTemplateFacetValues

    void setDirectTemplateFacetValues(Cls cls,
                                      Slot slot,
                                      Facet facet,
                                      Collection values)

### getDirectSuperclasses

    List<Cls> getDirectSuperclasses(Cls cls)

### getSuperclasses

    Set getSuperclasses(Cls cls)

### getDirectSubclasses

    List<Cls> getDirectSubclasses(Cls cls)

### getSubclasses

    Set<Cls> getSubclasses(Cls cls)

### addDirectSuperclass

    void addDirectSuperclass(Cls cls,
                             Cls superclass)

### removeDirectSuperclass

    void removeDirectSuperclass(Cls cls,
                                Cls superclass)

### moveDirectSubclass

    void moveDirectSubclass(Cls cls,
                            Cls subclass,
                            int index)

### getDirectSuperslots

    List getDirectSuperslots(Slot slot)

### getSuperslots

    Set getSuperslots(Slot slot)

### getDirectSubslots

    List getDirectSubslots(Slot slot)

### getSubslots

    Set getSubslots(Slot slot)

### addDirectSuperslot

    void addDirectSuperslot(Slot slot,
                            Slot superslot)

### removeDirectSuperslot

    void removeDirectSuperslot(Slot slot,
                               Slot superslot)

### moveDirectSubslot

    void moveDirectSubslot(Slot slot,
                           Slot subslot,
                           int index)

### getDirectTypes

    List getDirectTypes(Instance instance)

### getTypes

    Set getTypes(Instance instance)

### getDirectInstances

    List<Instance> getDirectInstances(Cls cls)

### getInstances

    Set<Instance> getInstances(Cls cls)

### addDirectType

    void addDirectType(Instance instance,
                       Cls type)

### removeDirectType

    void removeDirectType(Instance instance,
                          Cls type)

### moveDirectType

    void moveDirectType(Instance instance,
                        Cls type,
                        int index)

### getEvents

    List<AbstractEvent> getEvents()

### executeQuery

    void executeQuery(Query query,
                      QueryCallback callback)

  The executeQuery method allows for complex queries. It is asynchronous so that in server-client mode the server knowledge base lock will not be held for an excessive amount of time. The contract specifies that the implementor must call one of the QueryCallback methods in a separate thread. This makes it possible for the caller to know how to retrieve the results in a synchronous way without worrying about deadlock.

  Parameters:
    `Query` - the query to be executed.
    `QueryCallback` - the callback that receives the results of the query.

### getReferences

    Set<Reference> getReferences(Object object)

### getMatchingReferences

    Set<Reference> getMatchingReferences(String string,
                                         int maxMatches)

### getClsesWithMatchingBrowserText

    Set<Cls> getClsesWithMatchingBrowserText(String string,
                                             Collection superclasses,
                                             int maxMatches)

### getFramesWithDirectOwnSlotValue

    Set<Frame> getFramesWithDirectOwnSlotValue(Slot slot,
                                               Object value)

### getFramesWithAnyDirectOwnSlotValue

    Set<Frame> getFramesWithAnyDirectOwnSlotValue(Slot slot)

### getFramesWithMatchingDirectOwnSlotValue

    Set<Frame> getFramesWithMatchingDirectOwnSlotValue(Slot slot,
                                                       String value,
                                                       int maxMatches)

### getClsesWithDirectTemplateSlotValue

    Set getClsesWithDirectTemplateSlotValue(Slot slot,
                                            Object value)

### getClsesWithAnyDirectTemplateSlotValue

    Set<Cls> getClsesWithAnyDirectTemplateSlotValue(Slot slot)

### getClsesWithMatchingDirectTemplateSlotValue

    Set getClsesWithMatchingDirectTemplateSlotValue(Slot slot,
                                                    String value,
                                                    int maxMatches)

### getClsesWithDirectTemplateFacetValue

    Set getClsesWithDirectTemplateFacetValue(Slot slot,
                                             Facet facet,
                                             Object value)

### getClsesWithMatchingDirectTemplateFacetValue

    Set getClsesWithMatchingDirectTemplateFacetValue(Slot slot,
                                                     Facet facet,
                                                     String value,
                                                     int maxMatches)

### getDirectOwnSlotValuesClosure

    Set getDirectOwnSlotValuesClosure(Frame frame,
                                      Slot slot)

### beginTransaction

    boolean beginTransaction(String name)

### commitTransaction

    boolean commitTransaction()

### rollbackTransaction

    boolean rollbackTransaction()

### getTransactionStatusMonitor

    TransactionMonitor getTransactionStatusMonitor()

  Retrieves a transaction status monitor for transactions. If this call returns null then it means that transactions are not supported.

  Returns:
    A TransactionMonitor object that tracks the status of transactions.

### close

    void close()

### replaceFrame

    void replaceFrame(Frame original,
                      Frame replacement)

Overview | Package | Class | Tree | Deprecated | Index | Help
| Protege 3.4 rc2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug report or feature request
Protégé is a trademark of Stanford University.
Copyright (c) 1998-2009 Stanford University.